# Template Matching App (aka xcorr)

## Setup

### A note on setting up the paths

In the `Example` directory you find everything necessary to start your own scan. Copy that directory anywhere you like.
The only thing you have to do is to provide the path to the actual code directory (this project here) within the `scipt.py`; by default, the relative path is preset to `../code_TM_app` and thus resembles the following structure: 

```
.
├── _sequences               <- You should be in this directory ("working directory") ...
│   └── script.py            <- ... when executing THIS file
│
└── _code_TM_app             <- The actual structure of this project 
    ├── TM
    └── README
```
So you need to:
1. Put all the code of this project into a folder called `code_TM_app` (a suggestion).
2. Copy or move the `Example` directory one level up and rename it to  `_sequences`  (a suggestion).

The `_sequences` directory will contain all data and results of different scans 
(e.g., different regions, different stations, different setups, etc.):

```
.
└── _sequences
    ├── data                                              <- (e.g., .sql script, .csv catalog)
    │   ├── SED-events_region1_{station}_mseed            <- Created automatically to contain 
    │   ├── SED-events_region2_{station}_mseed               catalog event waveforms and their plots
    │   └── ...
    │
    ├── results_region1_{station}_{startdate}_{enddate}   <- The results of a particular run on your sequence 
    ├── results_region2_{station}_{startdate}_{enddate}      (with station name and date span)
    ├── ...
    └── script.py


```

If you want to separate different regions, you can also create a 'sequence'
directory for each sequence separately -- simply by creating a new folder
with the `scipt.py` inside.
In this way, you keep related data, but different setups
(e.g., different stations, BP filter limits, template durations, etc.)
together in a common directory:
```
.
├── _sequence_region1
│   ├── data
│   │   └── SED-events_region1_{station}_mseed
│   |
│   ├── results_region1_{station}_{startdate}_{enddate}
│   └── script.py
│
└── _sequence_region2
    ├── data
    │   └── SED-events_region2_{station}_mseed
    |
    ├── results_region2_{station}_{startdate}_{enddate}
    └── script.py
```


*[xcorr]: cross-correlation

