#!/bin/sh
# Plot catalog locations (and mark templates)
# 
#source ~/.alias
#shopt -s expand_aliases
DATAdir="../Info_BaselEGS"

DIR=$1

out=$DIR/"locations"

numTEMPLATES=$2


# Basel deep sensor
# 611658.8   270618.7  4422.3 
#bs1_x=611663 58.8-83.9; bs1_y=270618.7+98.6; bs1_dep=4422.3-13.6
# Basel casing shoe
# 611663 270611  4354.0
bs1_x=611663; bs1_y=270611; bs1_dep=4354.0;

awk '$1!~/#/{print $5-x,$6-y,$9-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/GEL_DB.dat.new > tmp1.dat
#awk '$1!~/#/&&$3~/2007/{print $5-x,$6-y,$9-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/GEL_DB.dat.new > tmp1_07.dat
#awk '$1!~/#/&&$3~/2008/{print $5-x,$6-y,$9-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/GEL_DB.dat.new > tmp1_08.dat
#awk '$1!~/#/&&$3~/2009/{print $5-x,$6-y,$9-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/GEL_DB.dat.new > tmp1_09.dat
#awk '$1!~/#/&&$3~/2010/{print $5-x,$6-y,$9-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/GEL_DB.dat.new > tmp1_10.dat

# Use GEL events with determined template associations (only if event was available and associated)
#GELdir=GELevent_analysis
#GELfile=$GELdir/foundGELevents_merged.dat
#cat $GELdir/foundGELevents_{main,post}*.dat >> $GELfile  # Merge all associations
GELfile=$DIR/GELevents_found_thresh0.40.dat

# Join files based on GEL event ID (using awk arrays)
# Expl: As long as in file1 (NR==FNR), write $5 into array A with $1 as ID. If reading file2 and if ID in array ($2 in A), write out desired fields + array element for ID
#awk 'NR==FNR{A[$1]=$5;next}($2 in A){print $5-x,$6-y,$9-z,A[$2]}' x=$bs1_x y=$bs1_y z=$bs1_dep $GELfile $DATAdir/GEL_DB.dat.new > tmp1+TPassoc.dat

# Events > M3
awk '$1!~/#/ && $NF>=3 && $10!~/-.-/ {
         if($3~/2006/){print "> -Wthickest,gray"} else {print "> -Wthickest,100"};
         print $10*1000-x,$12*1000-y,$14*1000-z,$NF}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/Nicos_relocu.all > tmpM3.dat

# The detections/templates
#awk 'NR>197 && $10!~/-.-/ {print $10*1000-x,$12*1000-y,$14*1000-z,$NF}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/Nicos_relocu.all > tmp2.dat
#awk '$0!~/#/ && NR!=13{print substr($(NF-1),3)}' $DIR/BA_logA_SC3.dat > tmp4.dat
#paste tmp2.dat tmp4.dat > tmp5.dat; mv tmp5.dat tmp2.dat
#awk '$0!~/#/ {print $2-x,$3-y,$4-z,$5,$NF}' x=$bs1_x y=$bs1_y z=$bs1_dep $DIR/loc_templateSet.dat > tmp2.dat
# ...with custom order
# Expl: As long as in file1 (NR==FNR), write the template number into array A with line number as ID. Later, print order in last column
awk 'NR==FNR{A[substr($1,3)]=substr($2,3);next}
	 {print $2-x,$3-y,$4-z,$5,A[$NF]}' x=$bs1_x y=$bs1_y z=$bs1_dep $DIR/timeline_template_order.dat $DIR/loc_templateSet.dat > tmp2.dat

# Trajectory
awk 'BEGIN{print "> -Wthickest,black"} NR>6 {if($NF<0&&n==0){print "> -Wthickest,blue";n=1}; print $1-x,$2-y,$5-z}' x=$bs1_x y=$bs1_y z=$bs1_dep $DATAdir/Trajectory_BS1.dat > tmp3.dat


# START PLOTTING
gmt set PS_MEDIA a2
#gmt set PS_PAGE_ORIENTATION landscape

gmt set FONT_LABEL 14
gmt set FONT_ANNOT_PRIMARY 12
gmt set MAP_ANNOT_OFFSET_PRIMARY .1c
gmt set MAP_LABEL_OFFSET .4c

# point size
ps="4p"
# cross size
cs=.5
# initial color
icol="black"
# final color
fcol="blue"
# signal color
scol="red"
# line color
lcol="darkgray"

# Make colormap
COLORMAP=colormap.cpt
COLORTABLE=panoply  # panoply, rainbow, jet, cyclic, haxby, wysiwyg
gmt makecpt -C$COLORTABLE --COLOR_BACKGROUND=lightgray -T1/`echo $numTEMPLATES | awk '{print $1*1+1}'`/1 > $COLORMAP

###################### MAP VIEW
R=`awk '$1!=">" {if ($1>-2000 && $2>-2000) {print $1, $2, 50,50}}' tmp[12].dat | gmt gmtinfo -Sxy -I1`
#psbasemap -Jx1:11000 -R-300/600/-700/400 -B200g100:"rel. easting [m]":/200g100:"rel. northing":WNse -K -P > $out.ps
gmt psbasemap -Jx1:11000 $R -B200g100:"rel. easting [m]":/200g100:"rel. northing":WnSe -K -P > $out.ps

## GEL locations
awk '{print $1, $2}' tmp1.dat | gmt psxy -R -Jx -Sc2p -G100 -O -K >> $out.ps
#awk '{print $1, $2, $NF}' tmp1+TPassoc.dat | gmt psxy -R -Jx -Sc2p -C$COLORMAP -O -K >> $out.ps
#awk '{print $1, $2}' tmp1_07.dat | gmt psxy -R -Jx -Sc4p -G100 -O -K >> $out.ps
#awk '{print $1, $2}' tmp1_08.dat | gmt psxy -R -Jx -Sc4p -W0 -Ggreen -O -K >> $out.ps
#awk '{print $1, $2}' tmp1_09.dat | gmt psxy -R -Jx -Sc4p -W0 -Gblue -O -K >> $out.ps
#awk '{print $1, $2}' tmp1_10.dat | gmt psxy -R -Jx -Sc4p -W0 -Gred -O -K >> $out.ps
#awk '{if($1==">"){print} else {print $1, $2,$(NF)/3}}' tmpM3.dat | gmt psxy -R -Jx -Sc -O -K >> $out.ps
awk '{if($1!=">"){print $1, $2,$(NF)/3}}' tmpM3.dat | gmt psxy -R -Jx -Sc -Wthicker,50 -O -K >> $out.ps
awk '{print $1, $2, $NF, 0.7*$(NF-1)}' tmp2.dat | sort -k4nr | gmt psxy -R -Jx -Ss -Wthick,black -C$COLORMAP -O -K >> $out.ps


###################### DEPTH-NORTHING VIEW
R=`awk '$1!=">" {if ($2>-2000 && $3>-2000) {print $3, $2, 50, 50}}' tmp[12].dat | gmt gmtinfo -Sxy -I1`
#psbasemap -Jx -R-600/500/-700/400  -B200g100:"rel. depth [m]":/200g100:"rel. northing":wNsE -X9.5 -O -K >> $out.ps
gmt psbasemap -Jx $R  -B200g100:"rel. depth [m]":/200g100:"rel. northing":wnSE -X11.5 -O -K >> $out.ps


## GEL locations
awk '{if($1==">"){print} else {print $3, $2}}' tmp3.dat | gmt psxy -R -Jx -O -K >> $out.ps
awk '{print $3, $2}' tmp1.dat | gmt psxy -R -Jx -Sc2p -G100 -O -K >> $out.ps
#awk '{print $3, $2, $NF}' tmp1+TPassoc.dat | gmt psxy -R -Jx -Sc2p -C$COLORMAP -O -K >> $out.ps
#awk '{print $3, $2}' tmp1_07.dat | gmt psxy -R -Jx -Sc4p -G100 -O -K >> $out.ps
#awk '{print $3, $2}' tmp1_08.dat | gmt psxy -R -Jx -Sc4p -W0 -Ggreen -O -K >> $out.ps
#awk '{print $3, $2}' tmp1_09.dat | gmt psxy -R -Jx -Sc4p -W0 -Gblue -O -K >> $out.ps
#awk '{print $3, $2}' tmp1_10.dat | gmt psxy -R -Jx -Sc4p -W0 -Gred -O -K >> $out.ps
#awk '{if($1==">"){print} else {print $3, $2,$(NF)/3}}' tmpM3.dat | gmt psxy -R -Jx -Sc -O -K >> $out.ps
awk '{if($1!=">"){print $3, $2,$(NF)/3}}' tmpM3.dat | gmt psxy -R -Jx -Sc -Wthicker,50 -O -K >> $out.ps
awk '{print $3, $2, $NF, 0.7*$(NF-1)}' tmp2.dat | sort -k4nr | gmt psxy -R -Jx -Ss -Wthick,black -C$COLORMAP -O >> $out.ps

### Convert to PS to PDF + PNG

# 1. PS to PDF
gmt psconvert $out.ps -A -Tf

# 2. PS to PNG
#ps2raster $out.ps -A -Q -Tg -E150 # This looks ugly!
#rm ps2raster*

# 2. PDF to PNG
#convert -density 100 -flatten -antialias +repage $out''.pdf $out''.png
convert -density 150 -flatten -antialias +repage -border 4 -bordercolor White $out''.pdf $out''.png


### Clean up
rm -f tmp*
rm $out.ps
rm $COLORMAP
rm gmt.conf

exit
