# plot relocation result
# 
#source ~/.alias
#shopt -s expand_aliases
DATAdir="../../data"
out="locations_"$1

NOWdir=$2
cd $NOWdir

numTEMPLATES=$3

## GMT settings
gmtset PAPER_MEDIA A3
gmtset PAGE_ORIENTATION landscape

gmtset BASEMAP_TYPE fancy+
gmtset BASEMAP_FRAME_RGB 0/0/0
gmtset PLOT_DEGREE_FORMAT +D.
gmtset FRAME_WIDTH 3p

gmtset GRID_PEN_PRIMARY 0.1p

gmtset LABEL_FONT_SIZE 12
gmtset ANNOT_FONT_SIZE_PRIMARY 8
gmtset ANNOT_OFFSET_PRIMARY .1c
gmtset LABEL_OFFSET .4c

# Make colormap
COLORMAP=colormap.cpt
COLORTABLE=panoply  # panoply, rainbow, jet, cyclic, haxby, wysiwyg
makecpt -C$COLORTABLE --COLOR_BACKGROUND=lightgray -T1/`echo $numTEMPLATES | awk '{print $1*1+1}'`/1 > $COLORMAP

###################### MAP VIEW
# For a constant dimensions among sequences
#R=$(minmax -C loc_catalog.dat | awk '{print "-R"$3+($4-$3)/2-0.025"/"$3+($4-$3)/2+0.025"/"$5+($6-$5)/2-0.019"/"$5+($6-$5)/2+0.019}')
# For an individual (tight) plot
R=$(awk '{print $2, $3, 0.05, 0.035}' loc_catalog.dat | minmax -Sxy -I0.0001)

#psbasemap -JM320p $R -B0.05g0.01:"":/0.05g0.01:"":WnSe -K -P > $out.ps
psbasemap -JM320p $R -B0.1g0.1WnSe -K -P > $out.ps

# The TOPO
#TOPO=topo.grd
TOPO=srtm_ECOS.grd
TOPO_illu=srtm_ECOSi.grd
TOPOSCALE=heiner.cpt
# Prepare topography files (see /usr/share/gmt/dbase/grdraster.info)
#"SRTM30 e020n40"		"m"	-R-20/20/40/90		-I0.5m		P i 1 		0	none	W020N90.DEM B
#grdraster 8 $R -G$TOPO -V
#grdsample $TOPO -G$TOPO_TMP -I18c $VERBOSE
#grdgradient $TOPO_TMP -A0 -G$TOPO_illu -Nt0.5 $VERBOSE

# Plot topography + data
#grdimage $DATA_GRID $DEFAULT -JZ0.10i -C$COLORSCALE -I$TOPO_INTENS -E100 -Q -O -K >> $out.ps
#grdimage $TOPO $R -J -C$TOPOSCALE  -O -K>> $out.ps

# Fuck the above and use the prepared one for ECOS
grdimage $R -J $TOPO -I$TOPO_illu -C$TOPOSCALE -O -K >> $out.ps

#Plot coastlines
BOARDERS=-Na
#COAST=-W1/17/73/71
WATER=-S100/100/255
RIVERS=-I1/100/100/255
pscoast $R -J -Df $BOARDERS $COAST $RIVERS $WATER -O -K >> $out.ps

# The catalog events
awk '$0!~/#/ {mag=$5; {if (mag < 1)mag=1} print $2, $3, 0.05*mag^2}' loc_catalog.dat |\
	sort -k3nr |\
	psxy -R -J -Sc -Wthick,red -O -K >> $out.ps
# (sorting to plot the smaller over the bigger)

# Plot the names of sequences
awk '{print $1, $2, 12,  0,  0,  "CM", $3}'  loc_sequences.dat |\
	pstext -R -J -D0p/16p -N -Gred -O >> $out.ps


########### Convert to PDF + PNG
ps2raster $out.ps -A -Tf

convert -density 150 -flatten -antialias +repage -border 4 -bordercolor White $out''.pdf $out''.png

rm -f tmp*
rm $out.ps
rm ps2raster*
rm $COLORMAP

exit
